searchData={"items":[{"type":"module","title":"Buckets","doc":"Provides a generic interface for uploading files to buckets hosted by\ndifferent cloud providers.","ref":"Buckets.html"},{"type":"function","title":"Buckets.delete/2","doc":"Delegates a `delete/2` function call to the configured `:adapter`.","ref":"Buckets.html#delete/2"},{"type":"function","title":"Buckets.get/2","doc":"Delegates a `get/2` function call to the configured `:adapter`.","ref":"Buckets.html#get/2"},{"type":"function","title":"Buckets.put/3","doc":"Delegates a `put/3` function call to the configured `:adapter`.","ref":"Buckets.html#put/3"},{"type":"function","title":"Buckets.url/2","doc":"Delegates a `url/2` function call to the configured `:adapter`.","ref":"Buckets.html#url/2"},{"type":"behaviour","title":"Buckets.Adapter","doc":"","ref":"Buckets.Adapter.html"},{"type":"callback","title":"Buckets.Adapter.child_spec/2","doc":"Returns a child specification for processes this adapter needs, if any.\n\nThis callback is optional. Adapters that need supervised processes (like GCS\nauth servers) should implement this callback. Adapters that don't need any\nsupervised processes (like Volume, S3) can omit this callback entirely.\n\nWhen implemented, should return:\n- `child_spec()` - A supervisor child specification\n- `{:error, reason}` - Config is invalid\n\nExamples:\n- GCS adapter implements this to return auth server child spec\n- Volume/S3 adapters don't implement this callback at all","ref":"Buckets.Adapter.html#c:child_spec/2"},{"type":"callback","title":"Buckets.Adapter.delete/2","doc":"","ref":"Buckets.Adapter.html#c:delete/2"},{"type":"callback","title":"Buckets.Adapter.get/2","doc":"","ref":"Buckets.Adapter.html#c:get/2"},{"type":"callback","title":"Buckets.Adapter.put/3","doc":"","ref":"Buckets.Adapter.html#c:put/3"},{"type":"callback","title":"Buckets.Adapter.url/2","doc":"","ref":"Buckets.Adapter.html#c:url/2"},{"type":"callback","title":"Buckets.Adapter.validate_config/1","doc":"","ref":"Buckets.Adapter.html#c:validate_config/1"},{"type":"function","title":"Buckets.Adapter.validate_required/2","doc":"","ref":"Buckets.Adapter.html#validate_required/2"},{"type":"module","title":"Buckets.Adapters.GCS","doc":"Google Cloud Storage adapter for Buckets.\n\nThis adapter provides a native implementation for GCS operations using only\nthe `:req` HTTP client, without dependencies on `:google_api_storage`, `:gcs_signed_url`, or `:goth`.","ref":"Buckets.Adapters.GCS.html"},{"type":"module","title":"Setup - Buckets.Adapters.GCS","doc":"To use this adapter, you need to start your Cloud module in your application's\nsupervision tree to enable automatic token caching and refresh:\n\n    children = [\n      # ... your other processes\n      MyApp.Cloud\n    ]\n\n    Supervisor.start_link(children, opts)\n\nThe Cloud module will automatically start the required authentication processes for GCS locations.\n\nThe supervisor will automatically manage authentication tokens for each unique set of\nservice account credentials, refreshing them before they expire.","ref":"Buckets.Adapters.GCS.html#module-setup"},{"type":"module","title":"Configuration - Buckets.Adapters.GCS","doc":"You can configure GCS locations using either service account credentials as a JSON string\nor by providing a path to a service account JSON file:\n\n    config :my_app, MyCloud,\n      locations: [\n        gcs_direct: [\n          adapter: Buckets.Adapters.GCS,\n          bucket: \"my-bucket\",\n          path: \"uploads\",\n          service_account_credentials: System.fetch_env!(\"GOOGLE_CREDENTIALS\")\n        ],\n        gcs_from_file: [\n          adapter: Buckets.Adapters.GCS,\n          bucket: \"my-bucket\",\n          path: \"uploads\",\n          service_account_path: \"path/to/service-account.json\"\n        ]\n      ]\n\nThe `:service_account_credentials` option accepts a JSON string, making it easy to pass\ncredentials via environment variables:\n\n    service_account_credentials: System.get_env(\"GCS_SERVICE_ACCOUNT_JSON\")","ref":"Buckets.Adapters.GCS.html#module-configuration"},{"type":"module","title":"Performance - Buckets.Adapters.GCS","doc":"This implementation automatically caches and refreshes Google Cloud access tokens,\nsignificantly reducing latency compared to generating new tokens for each request.\nTokens are refreshed 5 minutes before expiration to ensure uninterrupted service.","ref":"Buckets.Adapters.GCS.html#module-performance"},{"type":"function","title":"Buckets.Adapters.GCS.url/2","doc":"Gets a signed URL for temporarily delegating access to an object in a bucket.","ref":"Buckets.Adapters.GCS.html#url/2"},{"type":"function","title":"Errors - Buckets.Adapters.GCS.url/2","doc":"* 403 PERMISSION_DENIED: Permission 'iam.serviceAccounts.signBlob' denied on resource\n      (or it may not exist). Make sure the authorized SA has role roles/iam.serviceAccountTokenCreator\n      on the SA passed in the URL.\n\n    * 403 PERMISSION_DENIED: IAM Service Account Credentials API has not been used in project {project_id}\n      before or it is disabled. Enable it by visiting {url} then retry. If you enabled this API recently,\n      wait a few minutes for the action to propagate to our systems and retry. Make sure the authorized SA\n      has role roles/iam.serviceAccountTokenCreator on the SA passed in the URL.\"","ref":"Buckets.Adapters.GCS.html#url/2-errors"},{"type":"module","title":"Buckets.Adapters.GCS.Auth","doc":"Google Cloud Storage authentication using service account credentials.\n\nHandles JWT token generation and OAuth2 token exchange without external dependencies.","ref":"Buckets.Adapters.GCS.Auth.html"},{"type":"function","title":"Buckets.Adapters.GCS.Auth.exchange_jwt_for_token/1","doc":"Exchanges a JWT token for an access token via Google's OAuth2 endpoint.","ref":"Buckets.Adapters.GCS.Auth.html#exchange_jwt_for_token/1"},{"type":"function","title":"Buckets.Adapters.GCS.Auth.generate_jwt/1","doc":"Generates a JWT token for Google service account authentication.","ref":"Buckets.Adapters.GCS.Auth.html#generate_jwt/1"},{"type":"function","title":"Buckets.Adapters.GCS.Auth.get_access_token/1","doc":"Gets an access token for GCS API access.","ref":"Buckets.Adapters.GCS.Auth.html#get_access_token/1"},{"type":"function","title":"Examples - Buckets.Adapters.GCS.Auth.get_access_token/1","doc":"iex> credentials = %{\n    ...>   \"client_email\" => \"test@example.com\",\n    ...>   \"private_key\" => \"-----BEGIN PRIVATE KEY-----\\n...\\n-----END PRIVATE KEY-----\"\n    ...> }\n    iex> Buckets.GCS.Auth.get_access_token(credentials)\n    {:ok, \"ya29.c.Ko8...\"}","ref":"Buckets.Adapters.GCS.Auth.html#get_access_token/1-examples"},{"type":"function","title":"Buckets.Adapters.GCS.Auth.get_credentials/1","doc":"Get service account credentials from a location config.","ref":"Buckets.Adapters.GCS.Auth.html#get_credentials/1"},{"type":"function","title":"Buckets.Adapters.GCS.Auth.load_credentials/1","doc":"Loads service account credentials from a file path.","ref":"Buckets.Adapters.GCS.Auth.html#load_credentials/1"},{"type":"function","title":"Buckets.Adapters.GCS.Auth.parse_credentials/1","doc":"Parse service account credentials from a JSON string.","ref":"Buckets.Adapters.GCS.Auth.html#parse_credentials/1"},{"type":"function","title":"Buckets.Adapters.GCS.Auth.validate_credentials/1","doc":"Validates that service account credentials contain required fields.","ref":"Buckets.Adapters.GCS.Auth.html#validate_credentials/1"},{"type":"module","title":"Buckets.Adapters.GCS.AuthServer","doc":"GenServer that manages Google Cloud Storage access tokens.\n\nAutomatically refreshes tokens before they expire to ensure\nuninterrupted access to GCS APIs.","ref":"Buckets.Adapters.GCS.AuthServer.html"},{"type":"function","title":"Buckets.Adapters.GCS.AuthServer.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Buckets.Adapters.GCS.AuthServer.html#child_spec/1"},{"type":"function","title":"Buckets.Adapters.GCS.AuthServer.get_token/1","doc":"Gets a valid access token from a specific server, refreshing if necessary.","ref":"Buckets.Adapters.GCS.AuthServer.html#get_token/1"},{"type":"function","title":"Buckets.Adapters.GCS.AuthServer.refresh_token/1","doc":"Forces a token refresh.","ref":"Buckets.Adapters.GCS.AuthServer.html#refresh_token/1"},{"type":"function","title":"Buckets.Adapters.GCS.AuthServer.start_link/1","doc":"Starts the token server.\n\nIf opts[:cloud] exists, starts in named mode with the cloud module.\nOtherwise, treats opts as config and starts in nameless mode.","ref":"Buckets.Adapters.GCS.AuthServer.html#start_link/1"},{"type":"module","title":"Buckets.Adapters.GCS.Signature","doc":"Google Cloud Storage V4 signed URL generation.\n\nImplements the V4 signing process for creating signed URLs that allow\ntemporary access to GCS objects without requiring authentication.","ref":"Buckets.Adapters.GCS.Signature.html"},{"type":"function","title":"Buckets.Adapters.GCS.Signature.generate_v4/4","doc":"Generates a V4 signed URL for Google Cloud Storage.","ref":"Buckets.Adapters.GCS.Signature.html#generate_v4/4"},{"type":"function","title":"Options - Buckets.Adapters.GCS.Signature.generate_v4/4","doc":"* `:verb` - HTTP method (default: \"GET\")\n  * `:expires` - Expiration time in seconds from now (default: 3600)\n  * `:headers` - Additional headers to include in the signature","ref":"Buckets.Adapters.GCS.Signature.html#generate_v4/4-options"},{"type":"function","title":"Examples - Buckets.Adapters.GCS.Signature.generate_v4/4","doc":"iex> credentials = %{\"client_email\" => \"test@example.com\", \"private_key\" => \"...\"}\n    iex> Buckets.Adapters.GCS.Signature.generate_v4(credentials, \"my-bucket\", \"path/to/object.jpg\")\n    {:ok, \"https://storage.googleapis.com/my-bucket/path%2Fto%2Fobject.jpg?X-Goog-Algorithm=...\"}","ref":"Buckets.Adapters.GCS.Signature.html#generate_v4/4-examples"},{"type":"module","title":"Buckets.Adapters.S3","doc":"","ref":"Buckets.Adapters.S3.html"},{"type":"module","title":"Buckets.Adapters.Volume","doc":"","ref":"Buckets.Adapters.Volume.html"},{"type":"function","title":"Buckets.Adapters.Volume.verify_signed_path/3","doc":"","ref":"Buckets.Adapters.Volume.html#verify_signed_path/3"},{"type":"behaviour","title":"Buckets.Cloud","doc":"Defines a cloud.\n\nA cloud manages the movement of files and data between your application and\na remote bucket for persistent storage.\n\nWhen used, it expects `:otp_app` as an option:\n\n    defmodule MyApp.Cloud do\n      use Buckets.Cloud,\n        otp_app: :my_app\n    end\n\nConfiguration is fetched from the application config, using a combination of\n`:otp_app` and the module that you defined:\n\n    config :my_app, MyApp.Cloud,\n      adapter: Buckets.Adapters.Volume,\n      bucket: \"tmp/buckets_volume\",\n      base_url: \"http://localhost:4000\"\n\nEach Cloud module corresponds to a single storage backend, similar to how\nEcto.Repo modules correspond to a single database. For multi-cloud applications,\ndefine multiple Cloud modules:\n\n    defmodule MyApp.VolumeCloud do\n      use Buckets.Cloud, otp_app: :my_app\n    end\n\n    defmodule MyApp.GCSCloud do\n      use Buckets.Cloud, otp_app: :my_app\n    end\n\n    defmodule MyApp.S3Cloud do\n      use Buckets.Cloud, otp_app: :my_app\n    end\n\nYou may also specify config dynamically at runtime, using the `:config` opt\nwhere it is supported.","ref":"Buckets.Cloud.html"},{"type":"behaviour","title":"Supervision - Buckets.Cloud","doc":"Cloud modules start a supervisor that manages any background processes required \nby the configured adapter. Some adapters (like GCS) need authentication servers,\nwhile others (like Volume, S3) don't need any supervised processes.\n\n**Only add Cloud modules to your supervision tree if they need background processes.**\nIf you add a Cloud module that doesn't need supervision (Volume, S3), you'll see\na warning message suggesting you remove it to avoid unnecessary overhead.\n\n    # Only needed for adapters that require background processes (like GCS)\n    children = [\n      MyApp.GCSCloud  # GCS needs auth servers\n      # MyApp.VolumeCloud - Not needed, would show warning\n      # MyApp.S3Cloud - Not needed, would show warning\n    ]","ref":"Buckets.Cloud.html#module-supervision"},{"type":"behaviour","title":"Dynamic Configuration - Buckets.Cloud","doc":"For multi-tenant applications where cloud configurations are determined at runtime,\nevery Cloud module supports dynamic configuration using the process dictionary,\nsimilar to Ecto's dynamic repositories.","ref":"Buckets.Cloud.html#module-dynamic-configuration"},{"type":"behaviour","title":"Usage - Buckets.Cloud","doc":"There are two ways to use dynamic configuration:\n\n#### 1. Scoped Configuration (like Ecto transactions)\n\nUse `with_config/2` for temporary configuration:\n\n    # Define the runtime configuration\n    config = [\n      adapter: Buckets.Adapters.S3,\n      bucket: \"user-bucket\",\n      access_key_id: \"AKIA...\",\n      secret_access_key: \"secret...\",\n      region: \"us-east-1\"\n    ]\n\n    # Execute operations with the dynamic config\n    {:ok, object} = MyApp.Cloud.with_config(config, fn ->\n      MyApp.Cloud.insert(\"file.pdf\")\n      MyApp.Cloud.insert(\"another.pdf\")  # Same config\n    end)\n\n#### 2. Process-Local Configuration (like Ecto.Repo.put_dynamic_repo)\n\nUse `put_dynamic_config/1` for persistent configuration in the current process:\n\n    # Set dynamic config for this process\n    :ok = MyApp.Cloud.put_dynamic_config([\n      adapter: Buckets.Adapters.GCS,\n      bucket: \"tenant-specific-bucket\",\n      service_account_credentials: tenant.credentials\n    ])\n\n    # All subsequent operations use the dynamic config\n    {:ok, object1} = MyApp.Cloud.insert(\"file1.pdf\")\n    {:ok, object2} = MyApp.Cloud.insert(\"file2.pdf\")","ref":"Buckets.Cloud.html#module-usage"},{"type":"behaviour","title":"Auth Server Management - Buckets.Cloud","doc":"Auth servers (for GCS) are automatically started and cached per-process as needed.\nYou don't need any special configuration or supervision setup for dynamic clouds.","ref":"Buckets.Cloud.html#module-auth-server-management"},{"type":"callback","title":"Buckets.Cloud.delete/1","doc":"Deletes a `Buckets.Object` permanently.","ref":"Buckets.Cloud.html#c:delete/1"},{"type":"callback","title":"Buckets.Cloud.delete!/1","doc":"Same as `c:delete/1` but returns the object or raises if there is an error.","ref":"Buckets.Cloud.html#c:delete!/1"},{"type":"callback","title":"Buckets.Cloud.insert/2","doc":"Inserts a `Buckets.Object` or a file from a path into a bucket.","ref":"Buckets.Cloud.html#c:insert/2"},{"type":"callback","title":"Buckets.Cloud.insert!/2","doc":"Same as `c:insert/2` but returns the object or raises if there is an error.","ref":"Buckets.Cloud.html#c:insert!/2"},{"type":"callback","title":"Buckets.Cloud.live_upload/2","doc":"Returns a map to be used as configuration for a LiveView live upload. The configuration\ncontains a signed URL that permits the upload to a remote bucket. Requires that an `:uploader`\nis configured for the location that the file is being uploaded to.","ref":"Buckets.Cloud.html#c:live_upload/2"},{"type":"callback","title":"Buckets.Cloud.live_upload!/2","doc":"Same as `c:live_upload/1` but returns the upload config or raises if there is an error.","ref":"Buckets.Cloud.html#c:live_upload!/2"},{"type":"callback","title":"Buckets.Cloud.load/2","doc":"Loads the data for a `Buckets.Object`, placing it in memory by default. It will load data\nlazily, doing nothing if data is already present.","ref":"Buckets.Cloud.html#c:load/2"},{"type":"callback","title":"Options - Buckets.Cloud.load/2","doc":"* `:to` - A location to store the loaded data to on disk, if this is preferred over\n      loading to memory. May be a path, `:tmp` (to load to the configured tmp dir), or\n      `{:tmp, path}` (to load to a path in the configured tmp dir).\n    * `:force` - If data is already present, first unload it with `c:unload/1` before loading\n      new data. Warning: if data is stored in a file, it will be deleted.","ref":"Buckets.Cloud.html#c:load/2-options"},{"type":"callback","title":"Buckets.Cloud.load!/2","doc":"Same as `c:load/1` but returns the object or raises if there is an error.","ref":"Buckets.Cloud.html#c:load!/2"},{"type":"callback","title":"Buckets.Cloud.normalize_filename/1","doc":"An overridable function that processes filenames before encoding them in a remote path.\n\nBy default, replaces whitespace with `\"_\"` and removes all non-alphanumeric characters.","ref":"Buckets.Cloud.html#c:normalize_filename/1"},{"type":"callback","title":"Buckets.Cloud.read/1","doc":"Reads the data for `Buckets.Object`, preferring local data first and fetching from\nthe remote bucket if needed.","ref":"Buckets.Cloud.html#c:read/1"},{"type":"callback","title":"Buckets.Cloud.read!/1","doc":"Same as `c:read/1` but returns the data or raises if there is an error.","ref":"Buckets.Cloud.html#c:read!/1"},{"type":"callback","title":"Buckets.Cloud.tmp_dir/0","doc":"An overridable function that specifies the temporary directory in which objects are stored.\n\nDefaults to `System.tmp_dir!()`.","ref":"Buckets.Cloud.html#c:tmp_dir/0"},{"type":"callback","title":"Buckets.Cloud.unload/1","doc":"Unloads the data for a `Buckets.Object`. If the data is stored in a local file, the file will\nbe deleted.","ref":"Buckets.Cloud.html#c:unload/1"},{"type":"callback","title":"Buckets.Cloud.url/1","doc":"Returns a SignedURL struct for a `Buckets.Object`.","ref":"Buckets.Cloud.html#c:url/1"},{"type":"callback","title":"Buckets.Cloud.url!/2","doc":"Same as `c:url/1` but returns the SignedURL raises if there is an error.","ref":"Buckets.Cloud.html#c:url!/2"},{"type":"module","title":"Buckets.Cloud.Dynamic","doc":"Dynamic configuration management for Cloud modules.\n\nThis module provides functions for managing runtime configuration changes,\nallowing Cloud modules to switch between different adapters and configurations\non a per-process basis, similar to `Ecto.Repo.put_dynamic_repo/1`.","ref":"Buckets.Cloud.Dynamic.html"},{"type":"module","title":"Usage - Buckets.Cloud.Dynamic","doc":"These functions are automatically available on Cloud modules that use \n`Buckets.Cloud`. You typically don't need to call this module directly.","ref":"Buckets.Cloud.Dynamic.html#module-usage"},{"type":"module","title":"Process-Local Configuration - Buckets.Cloud.Dynamic","doc":"MyApp.Cloud.put_dynamic_config([\n      adapter: Buckets.Adapters.GCS,\n      bucket: \"tenant-bucket\",\n      service_account_credentials: credentials\n    ])","ref":"Buckets.Cloud.Dynamic.html#module-process-local-configuration"},{"type":"module","title":"Scoped Configuration - Buckets.Cloud.Dynamic","doc":"MyApp.Cloud.with_config(config, fn ->\n      MyApp.Cloud.insert(\"file.pdf\")\n    end)","ref":"Buckets.Cloud.Dynamic.html#module-scoped-configuration"},{"type":"module","title":"Auth Server Management - Buckets.Cloud.Dynamic","doc":"For adapters that need background processes (like GCS auth servers), these\nare automatically started and cached per-process as needed through the\nadapter's `prepare_dynamic_config/1` callback.","ref":"Buckets.Cloud.Dynamic.html#module-auth-server-management"},{"type":"function","title":"Buckets.Cloud.Dynamic.config/2","doc":"Gets the current configuration for the given cloud module.\n\nChecks the process dictionary first for dynamic config, falls back to static config.","ref":"Buckets.Cloud.Dynamic.html#config/2"},{"type":"function","title":"Buckets.Cloud.Dynamic.put_dynamic_config/2","doc":"Sets dynamic configuration for the current process.\n\nThis configuration will be used for all subsequent operations in this process\nuntil changed or deleted.","ref":"Buckets.Cloud.Dynamic.html#put_dynamic_config/2"},{"type":"function","title":"Buckets.Cloud.Dynamic.with_config/3","doc":"Executes a function with a specific configuration.\n\nThe configuration is only active during the execution of the function.\nPrevious configuration is restored afterwards.","ref":"Buckets.Cloud.Dynamic.html#with_config/3"},{"type":"module","title":"Buckets.Cloud.Operations","doc":"","ref":"Buckets.Cloud.Operations.html"},{"type":"function","title":"Buckets.Cloud.Operations.delete/1","doc":"","ref":"Buckets.Cloud.Operations.html#delete/1"},{"type":"function","title":"Buckets.Cloud.Operations.delete!/1","doc":"","ref":"Buckets.Cloud.Operations.html#delete!/1"},{"type":"function","title":"Buckets.Cloud.Operations.insert/3","doc":"","ref":"Buckets.Cloud.Operations.html#insert/3"},{"type":"function","title":"Buckets.Cloud.Operations.insert!/3","doc":"","ref":"Buckets.Cloud.Operations.html#insert!/3"},{"type":"function","title":"Buckets.Cloud.Operations.live_upload/3","doc":"","ref":"Buckets.Cloud.Operations.html#live_upload/3"},{"type":"function","title":"Buckets.Cloud.Operations.live_upload!/3","doc":"","ref":"Buckets.Cloud.Operations.html#live_upload!/3"},{"type":"function","title":"Buckets.Cloud.Operations.load/3","doc":"","ref":"Buckets.Cloud.Operations.html#load/3"},{"type":"function","title":"Buckets.Cloud.Operations.load!/3","doc":"","ref":"Buckets.Cloud.Operations.html#load!/3"},{"type":"function","title":"Buckets.Cloud.Operations.read/1","doc":"","ref":"Buckets.Cloud.Operations.html#read/1"},{"type":"function","title":"Buckets.Cloud.Operations.read!/1","doc":"","ref":"Buckets.Cloud.Operations.html#read!/1"},{"type":"function","title":"Buckets.Cloud.Operations.unload/1","doc":"","ref":"Buckets.Cloud.Operations.html#unload/1"},{"type":"function","title":"Buckets.Cloud.Operations.url/2","doc":"","ref":"Buckets.Cloud.Operations.html#url/2"},{"type":"function","title":"Buckets.Cloud.Operations.url!/2","doc":"","ref":"Buckets.Cloud.Operations.html#url!/2"},{"type":"module","title":"Buckets.Cloud.Supervisor","doc":"Supervisor that manages any processes required by cloud adapters.\n\nThis supervisor is used internally by Cloud modules to automatically\nstart any required processes for configured adapters by calling the\nadapter's `child_spec/1` callback. Adapters that don't need supervised\nprocesses (like Volume, S3) return `nil`, while adapters that need\nbackground processes (like GCS auth servers) return proper child specs.","ref":"Buckets.Cloud.Supervisor.html"},{"type":"function","title":"Buckets.Cloud.Supervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Buckets.Cloud.Supervisor.html#child_spec/1"},{"type":"function","title":"Buckets.Cloud.Supervisor.start_link/1","doc":"Starts the supervisor with a Cloud module.","ref":"Buckets.Cloud.Supervisor.html#start_link/1"},{"type":"module","title":"Buckets.Location","doc":"Represents a storage location for a Buckets.Object.\n\nThe config field can be either:\n- A keyword list with adapter configuration\n- A Cloud module atom that implements the Buckets.Cloud behaviour","ref":"Buckets.Location.html"},{"type":"function","title":"Buckets.Location.get_config/1","doc":"Gets the configuration from a Location.\n\nIf the config is a keyword list, returns it as-is.\nIf the config is a Cloud module, calls the module's config/0 function.","ref":"Buckets.Location.html#get_config/1"},{"type":"function","title":"Buckets.Location.new/2","doc":"","ref":"Buckets.Location.html#new/2"},{"type":"type","title":"Buckets.Location.t/0","doc":"","ref":"Buckets.Location.html#t:t/0"},{"type":"module","title":"Buckets.Location.NotConfigured","doc":"","ref":"Buckets.Location.NotConfigured.html"},{"type":"module","title":"Buckets.Object","doc":"","ref":"Buckets.Object.html"},{"type":"function","title":"Buckets.Object.from_file/1","doc":"","ref":"Buckets.Object.html#from_file/1"},{"type":"function","title":"Buckets.Object.from_upload/1","doc":"","ref":"Buckets.Object.html#from_upload/1"},{"type":"function","title":"Buckets.Object.new/3","doc":"","ref":"Buckets.Object.html#new/3"},{"type":"function","title":"Buckets.Object.read/1","doc":"","ref":"Buckets.Object.html#read/1"},{"type":"function","title":"Buckets.Object.read!/1","doc":"","ref":"Buckets.Object.html#read!/1"},{"type":"type","title":"Buckets.Object.t/0","doc":"","ref":"Buckets.Object.html#t:t/0"},{"type":"module","title":"Buckets.Router","doc":"","ref":"Buckets.Router.html"},{"type":"macro","title":"Buckets.Router.buckets_volume/2","doc":"","ref":"Buckets.Router.html#buckets_volume/2"},{"type":"function","title":"Buckets.Router.scope/0","doc":"","ref":"Buckets.Router.html#scope/0"},{"type":"module","title":"Buckets.Router.VolumeController","doc":"","ref":"Buckets.Router.VolumeController.html"},{"type":"function","title":"Buckets.Router.VolumeController.get/2","doc":"","ref":"Buckets.Router.VolumeController.html#get/2"},{"type":"function","title":"Buckets.Router.VolumeController.put/2","doc":"","ref":"Buckets.Router.VolumeController.html#put/2"},{"type":"module","title":"Buckets.SignedURL","doc":"","ref":"Buckets.SignedURL.html"},{"type":"function","title":"Buckets.SignedURL.to_string/1","doc":"","ref":"Buckets.SignedURL.html#to_string/1"},{"type":"type","title":"Buckets.SignedURL.t/0","doc":"","ref":"Buckets.SignedURL.html#t:t/0"},{"type":"module","title":"Buckets.Telemetry","doc":"Telemetry events for Buckets.\n\nThis module defines telemetry events that other applications can attach to.","ref":"Buckets.Telemetry.html"},{"type":"module","title":"Event Format - Buckets.Telemetry","doc":"Events follow the convention: `[:buckets, component, operation, stage]`","ref":"Buckets.Telemetry.html#module-event-format"},{"type":"module","title":"Events - Buckets.Telemetry","doc":"","ref":"Buckets.Telemetry.html#module-events"},{"type":"module","title":"Cloud Operations - Buckets.Telemetry","doc":"* `[:buckets, :cloud, :insert, :start]` - Emitted when a file upload operation starts\n* `[:buckets, :cloud, :insert, :stop]` - Emitted when a file upload operation completes\n* `[:buckets, :cloud, :insert, :exception]` - Emitted when a file upload operation raises an exception\n* `[:buckets, :cloud, :delete, :start]` - Emitted when a file deletion operation starts\n* `[:buckets, :cloud, :delete, :stop]` - Emitted when a file deletion operation completes\n* `[:buckets, :cloud, :delete, :exception]` - Emitted when a file deletion operation raises an exception\n* `[:buckets, :cloud, :read, :start]` - Emitted when a file read operation starts\n* `[:buckets, :cloud, :read, :stop]` - Emitted when a file read operation completes\n* `[:buckets, :cloud, :read, :exception]` - Emitted when a file read operation raises an exception\n* `[:buckets, :cloud, :load, :start]` - Emitted when a file load operation starts\n* `[:buckets, :cloud, :load, :stop]` - Emitted when a file load operation completes\n* `[:buckets, :cloud, :load, :exception]` - Emitted when a file load operation raises an exception\n* `[:buckets, :cloud, :url, :start]` - Emitted when a URL generation operation starts\n* `[:buckets, :cloud, :url, :stop]` - Emitted when a URL generation operation completes\n* `[:buckets, :cloud, :url, :exception]` - Emitted when a URL generation operation raises an exception","ref":"Buckets.Telemetry.html#module-cloud-operations"},{"type":"module","title":"Adapter Operations - Buckets.Telemetry","doc":"* `[:buckets, :adapter, :put, :start]` - Emitted when an adapter put operation starts\n* `[:buckets, :adapter, :put, :stop]` - Emitted when an adapter put operation completes\n* `[:buckets, :adapter, :put, :exception]` - Emitted when an adapter put operation raises an exception\n* `[:buckets, :adapter, :get, :start]` - Emitted when an adapter get operation starts\n* `[:buckets, :adapter, :get, :stop]` - Emitted when an adapter get operation completes\n* `[:buckets, :adapter, :get, :exception]` - Emitted when an adapter get operation raises an exception\n* `[:buckets, :adapter, :url, :start]` - Emitted when an adapter URL generation starts\n* `[:buckets, :adapter, :url, :stop]` - Emitted when an adapter URL generation completes\n* `[:buckets, :adapter, :url, :exception]` - Emitted when an adapter URL generation raises an exception\n* `[:buckets, :adapter, :delete, :start]` - Emitted when an adapter delete operation starts\n* `[:buckets, :adapter, :delete, :stop]` - Emitted when an adapter delete operation completes\n* `[:buckets, :adapter, :delete, :exception]` - Emitted when an adapter delete operation raises an exception","ref":"Buckets.Telemetry.html#module-adapter-operations"},{"type":"module","title":"Authentication Operations - Buckets.Telemetry","doc":"* `[:buckets, :auth, :token, :fetch, :start]` - Emitted when token fetching starts\n* `[:buckets, :auth, :token, :fetch, :stop]` - Emitted when token fetching completes\n* `[:buckets, :auth, :token, :fetch, :exception]` - Emitted when token fetching raises an exception\n* `[:buckets, :auth, :token, :refresh, :start]` - Emitted when token refresh starts\n* `[:buckets, :auth, :token, :refresh, :stop]` - Emitted when token refresh completes\n* `[:buckets, :auth, :token, :refresh, :exception]` - Emitted when token refresh raises an exception","ref":"Buckets.Telemetry.html#module-authentication-operations"},{"type":"module","title":"Usage - Buckets.Telemetry","doc":"To attach to these events in your application:\n\n```elixir\n:telemetry.attach(\n  \"my-handler-id\",\n  [:buckets, :cloud, :insert, :start],\n  &MyApp.handle_cloud_insert/4,\n  nil\n)\n\ndef handle_cloud_insert(_event_name, measurements, metadata, _config) do\n  # Process the event\n  IO.inspect(measurements)\n  IO.inspect(metadata)\nend\n```\n\nYou may attach a default logger handler, if you want basic logs for all telemetry events:\n\n```elixir\nBuckets.Telemetry.attach_default_logger(:debug)\n```","ref":"Buckets.Telemetry.html#module-usage"},{"type":"function","title":"Buckets.Telemetry.attach_default_logger/1","doc":"Attaches a default structured JSON Telemetry handler for logging.","ref":"Buckets.Telemetry.html#attach_default_logger/1"},{"type":"function","title":"Buckets.Telemetry.default_handler_id/0","doc":"","ref":"Buckets.Telemetry.html#default_handler_id/0"},{"type":"function","title":"Buckets.Telemetry.detach_default_logger/0","doc":"Undoes `Buckets.Telemetry.attach_default_logger/1` by detaching the attached logger.","ref":"Buckets.Telemetry.html#detach_default_logger/0"},{"type":"function","title":"Examples - Buckets.Telemetry.detach_default_logger/0","doc":"Detach a previously attached logger:\n\n    :ok = Buckets.Telemetry.attach_default_logger()\n    :ok = Buckets.Telemetry.detach_default_logger()\n\nAttempt to detach when a logger wasn't attached:\n\n    {:error, :not_found} = Buckets.Telemetry.detach_default_logger()","ref":"Buckets.Telemetry.html#detach_default_logger/0-examples"},{"type":"function","title":"Buckets.Telemetry.emit_event/3","doc":"Emits a telemetry event with the given name, measurements, and metadata.","ref":"Buckets.Telemetry.html#emit_event/3"},{"type":"function","title":"Buckets.Telemetry.handle_event/4","doc":"Default telemetry event handler that logs events.","ref":"Buckets.Telemetry.html#handle_event/4"},{"type":"function","title":"Buckets.Telemetry.span/3","doc":"Wraps a function call with start and stop telemetry events.","ref":"Buckets.Telemetry.html#span/3"},{"type":"function","title":"Buckets.Telemetry.start_event/2","doc":"Emits a start event and returns a function to emit the corresponding stop event.\n\nThis is useful for span-like events where you want to measure the duration of an operation.","ref":"Buckets.Telemetry.html#start_event/2"},{"type":"module","title":"Buckets.Util","doc":"","ref":"Buckets.Util.html"},{"type":"function","title":"Buckets.Util.normalize_filename/1","doc":"","ref":"Buckets.Util.html#normalize_filename/1"},{"type":"function","title":"Buckets.Util.size/1","doc":"","ref":"Buckets.Util.html#size/1"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,49]}}